﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Runtime.Serialization;
using System.Runtime.Serialization.Formatters.Binary;
using System.Text;
using System.Threading.Tasks;

namespace SerializationTest
{
    class Program
    {
        static void Main(string[] args)
        {
            List<Owner> owners = new List<Owner>();
            Owner owner = new Owner("1", "Henrik");
            owners.Add(owner);
    
            //Car car = new Car("VW Passat", "XX12345");
            //car.Owner = owners[0];

            //Console.WriteLine(car);
            //IFormatter formatter = new BinaryFormatter();
            //Stream stream = new FileStream("Car.bin", FileMode.Create, FileAccess.Write, FileShare.None);
            //formatter.Serialize(stream,car);
            //stream.Close();

            //stream = new FileStream("Car.bin", FileMode.Open, FileAccess.Read, FileShare.Read);
            //Car car2 = (Car)formatter.Deserialize(stream);
            //Console.WriteLine(car2);
            //stream.Close();

            List<Car> cars = new List<Car>();
            Car car = new Car("BMW-320i", "YY12345");
            car.Owner = owners[0];
            cars.Add(car);

            car = new Car("Audi-A6", "ZZ12345");
            car.Owner = owners[0];
            cars.Add(car);

            
            Stream stream = new FileStream("Cars.bin", FileMode.Create, FileAccess.Write, FileShare.None);
            IFormatter formatter = new BinaryFormatter();
            formatter.Serialize(stream,cars);
            stream.Close();

            stream = new FileStream("Cars.bin", FileMode.Open, FileAccess.Read, FileShare.Read);
            List<Car> cars2 = (List<Car>)formatter.Deserialize(stream);
            stream.Close();

            foreach (Car c in cars2)
            {
                Console.WriteLine(c);
            }

            if (cars[0].Owner.Equals(cars[1].Owner))
            {
                Console.WriteLine("Owner is deserialized just one time");
            }
            else
            {
                Console.WriteLine("Owner is deserialized twice - since we are using default equals (checking for physical equivalence)");
            }


       //     List<List<Object>> lists = new List<List<object>>();
            var lists = new List<Object>();
            lists.Add(cars);
            lists.Add(owners);

            //stream = new FileStream("Lists.bin", FileMode.Create, FileAccess.Write, FileShare.None);
            //formatter.Serialize(stream, lists);
            //stream.Close();


            //stream = new FileStream("Lists.bin", FileMode.Open, FileAccess.Read, FileShare.Read);
            //List<Object> lists2 = (List<Object>)formatter.Deserialize(stream);
            //stream.Close();

            stream = new FileStream("Lists2.bin", FileMode.Create, FileAccess.Write, FileShare.None);
            formatter.Serialize(stream, cars);
            formatter.Serialize(stream, owners);
            stream.Close();


            stream = new FileStream("Lists2.bin", FileMode.Open, FileAccess.Read, FileShare.Read);
            List<Car> cars3 = (List<Car>)formatter.Deserialize(stream);
            List<Owner> owners3 = (List<Owner>)formatter.Deserialize(stream);
            stream.Close();

            //List<Car> cars3 = (List<Car>)lists2[0];
            //List<Owner> owners3 = (List<Owner>)lists2[1];

            if (cars3[0].Owner.Equals(owners3[0]))
            {
                Console.WriteLine("Owner is deserialized just one time");
            }
            else
            {
                Console.WriteLine("Owner is deserialized twice - since we are using default equals (checking for physical equivalence)");
            }

            if (cars3[0].Owner.Equals(cars3[1].Owner))
            {
                Console.WriteLine("Owner is deserialized just one time");
            }
            else
            {
                Console.WriteLine("Owner is deserialized twice - since we are using default equals (checking for physical equivalence)");
            }
        }
    }
}
